/***
*		off2cc.c - convert noteoffs to cc
*		 1999 Michael Rees (aka Another Option)   All rights reserved.
***/

/*
=============================================================================
|   DATE   | WHAT
=============================================================================
  3 Dec 99 | created from vcc.c
*/

#define DBUG 0
//#define FILEDUMP

#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <intuition/intuition.h>
#include <string.h>

#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <clib/alib_protos.h>
#include <clib/alib_stdio_protos.h>
#include <stdarg.h>

#include "bars.h"
#include "BarsMacros.h"
#include "BPLib.h"
#include "proto/off2cc_protos.h"
#include "ToolID.h"
#include "off2ccw.h"
#include "debug.h"
#include "/icons/off2cc.h"

static UBYTE const versiontag[] = "$VER: Off2CC 40.1 (03.12.99)";

struct off2ccTool {
	struct Tool tool;
	UBYTE flags;
	UBYTE cc;          // controller to send
	UWORD _word_pad_;
};

#define SHOW_CCNUMS 1

#define TOOLID o2cc_TOOLID

#define TOOL_SIZE sizeof(struct off2ccTool)

extern struct IntuitionBase *IntuitionBase;
extern struct GfxBase *GfxBase;
extern struct LayersBase *LayersBase;
extern struct DOSBase *DOSBase;
extern struct ExecBase *SysBase;
extern struct Functions *functions;

/*==========================================================================
* inittool
*
*  INPUT: pointer to tool
* RETURN: none
*
* EFFECT: sets tool defaults
*=========================================================================*/

static void __regargs inittool(struct off2ccTool *tool)

{
	tool->flags = SHOW_CCNUMS;
	tool->cc = 64;
	tool->tool.touched |= TOUCH_INIT;
}

/*==========================================================================
* processevent
*=========================================================================*/

static struct Event * __stdargs __saveds processevent(struct Event *event)

{
   struct off2ccTool *tool = (struct off2ccTool *)event->tool;
	struct Event *dupe;

	if (!tool->tool.touched) inittool(tool);
	event->tool = tool->tool.next;
	if (IsNoteOff(event)) {
		dupe = (struct Event *)functions->myalloc(sizeof(struct Event),0);
		if (dupe) {
			memset((char *)dupe,0,sizeof(struct Event));
			memcpy((char *)dupe,(char *)event,sizeof(struct Event));
			dupe->next = event;
			dupe->status = MIDI_CCHANGE;
			dupe->byte1 = tool->cc;
			dupe->byte2 = event->byte1;
		}
		else dupe = event;
	}
	else dupe = event;
	return(dupe);
}

/*==========================================================================
* processlist
*=========================================================================*/
/*
static struct Event * __saveds __stdargs processlist(struct off2ccTool *tool,
                                                     struct Event *list,
                                                     long start, long stop)

{
	return(list);
}
*/

/************************************************************************/

static long __regargs esprintf(char *buffer, const char *command, ...)
{
	va_list arglist;

	va_start(arglist,command);
	RawDoFmt((STRPTR)command,(APTR)arglist,(void(*))("\x16\xC0\x4E\x75"),
	         (APTR)buffer);
	va_end(arglist);
	return((long)strlen(buffer));
}

struct off2ccTool *selectedtool;

/*==========================================================================
* hiloCCName
*=========================================================================*/

static long __stdargs __saveds hiloCCName(struct Window *w,struct Gadget *g,long x)

{
	static char *name[] = {
/*0 - 4 */	"MonPres", "ModWhel", "Breath ", "MIDI 03", "Foot   ",
/*5 - 9 */	"PortTim", "DataEnt", "Volume ", "Balance", "MIDI 09",
/*10-14 */	"Pan    ", "Express", "MIDI 12", "MIDI 13", "MIDI 14",
/*15-19 */	"MIDI 15", "Genl 1 ", "Genl 2 ", "Genl 3 ", "Genl 4 ",
/*20-24 */	"MIDI 20", "MIDI 21", "MIDI 22", "MIDI 23", "MIDI 24",
/*25-29 */	"MIDI 25", "MIDI 26", "MIDI 27", "MIDI 28", "MIDI 29",
/*30-34 */	"MIDI 30", "MIDI 31", "MIDI 32", "MIDI 33", "MIDI 34",
/*35-39 */	"MIDI 35", "MIDI 36", "MIDI 37", "MIDI 38", "MIDI 39",
/*40-44 */	"MIDI 40", "MIDI 41", "MIDI 42", "MIDI 43", "MIDI 44",
/*45-49 */	"MIDI 45", "MIDI 46", "MIDI 47", "MIDI 48", "MIDI 49",
/*50-54 */	"MIDI 50", "MIDI 51", "MIDI 52", "MIDI 53", "MIDI 54",
/*55-59 */	"MIDI 55", "MIDI 56", "MIDI 57", "MIDI 58", "MIDI 59",
/*60-64 */	"MIDI 60", "MIDI 61", "MIDI 62", "MIDI 63", "Sustain",
/*65-69 */	"PortSwt", "Sosten.", "SoftPed", "MIDI 68", "FrezPdl",
/*70-74 */	"MIDI 70", "MIDI 71", "MIDI 72", "MIDI 73", "MIDI 74",
/*75-79 */	"LegtoSw", "MIDI 76", "MIDI 77", "MIDI 78", "MIDI 79",
/*80-84 */	"Genl 5 ", "Genl 6 ", "Genl 7 ", "Genl 8 ", "MIDI 84",
/*85-89 */	"MIDI 85", "MIDI 86", "MIDI 87", "MIDI 88", "MIDI 89",
/*90-94 */	"MIDI 90", "FXDepth", "TremDep", "ChorDep", "CelDep ",
/*95-99 */	"PhsrDep", "DataInc", "DataDec", "MIDI 98", "MIDI 99",
/*100-104*/	"MIDI100", "MIDI101", "MIDI102", "MIDI103", "MIDI104",
/*105-109*/	"MIDI105", "MIDI106", "MIDI107", "MIDI108", "MIDI109",
/*110-114*/	"MIDI110", "MIDI111", "MIDI112", "MIDI113", "MIDI114",
/*115-119*/	"MIDI115", "MIDI116", "MIDI117", "MIDI118", "MIDI119",
/*120-124*/	"MIDI120", "RsetCtl" /*, "LoclCtl", "AllOff ", "OmniOff",*/
/*125-127*/	/*"Omni On", "Mono On", "Poly On"*/
	};

	char text[8];

	SetRPort(w->RPort, g->LeftEdge+g->Width+XOffset, g->TopEdge+YOffset,
	         /*(g->Flags & GADGDISABLED) ? BP_DGREY : */ BP_WHITE, 0, JAM2);
	if (selectedtool->flags & SHOW_CCNUMS) {
		esprintf(text,"%3ld",x);
		strcat(&text[3],"    ");
		Text(w->RPort,text,7);
	}
	else {
		Text(w->RPort,name[x],7);
	}
	return(x);
}

#define tw tool->tool.window

/*==========================================================================
* edittool
*=========================================================================*/

static void __saveds __stdargs edittool(struct off2ccTool *tool)

{
	struct IntuiMessage *message;
	long class; 
	long code;
	struct Gadget *gadget;
	struct NewWindow *nw;
	struct Menu *menu;
	struct MenuItem *menuitem;
//	short menunum;
	UBYTE refresh;

	if (!(tool->tool.touched & TOUCH_INIT)) inittool(tool);
	nw=NewOpenEmbossedWindow(&NewWindowStructure1,&tool->tool,0,WTITLE);
	if (!nw) return;
	if (tool->flags & SHOW_CCNUMS) MenuItem1.Flags |= CHECKED;
	else MenuItem1.Flags &= ~CHECKED;
	if (menu = functions->DupeMenu(&MenuList1)) SetMenuStrip(tw,menu);
	else SetWindowTitles(tw,(UBYTE *)-1,MenuList1.MenuName);
	functions->FatEmbossedPropOn(tw,CC,CC+GDOWN,CC+GUP,hiloCCName,121,1);
	refresh = 255;

	/*** ui handling ***/
	for ( ; ; ) {
		if (refresh) {
			selectedtool = tool;
			functions->ModifyEmbossedProp(tw,CC,tool->cc,0,0,0,0,0);
			functions->DrawEmbossedProp(tw,CC);
		}
		message = (struct IntuiMessage *)functions->GetIntuiMessage(tw);
		class = message->Class;
		code = message->Code;
		gadget = (struct Gadget *)message->IAddress;
		ReplyMsg((struct Message *)message);
		class = functions->SystemGadgets(tw,class,gadget,code);

		if (class == CLOSEWINDOW) {
			break;
		}

		else if (class == MENUPICK) {
			while (code != MENUNULL) {
				menuitem = ItemAddress(menu,code);
				if (ITEMNUM(code) == 0) {
					tool->flags ^= SHOW_CCNUMS;
					refresh = 1;
				}
				code = menuitem->NextSelect;
			}
		}

		else if (class == GADGETDOWN) {
			selectedtool = tool;
			switch (gadget->GadgetID) {
				case CC :
					tool->cc = functions->DragEmbossedProp(tw,CC);
					refresh = 1;
					break;
				case CC+GUP :
					tool->cc = functions->ShiftEmbossedProp(tw,CC,1,0);
					refresh = 1;
					break;
				case CC+GDOWN :
					tool->cc = functions->ShiftEmbossedProp(tw,CC,-1,0);
					refresh = 1;
					break;
			}
		}
	}
	functions->FatEmbossedPropOff(tw,CC,CC+GDOWN,CC+GUP);
	NewCloseEmbossedWindow(&tool->tool,nw);
	if (menu) functions->DeleteMenu(menu);
}

static struct ToolMaster master;

/*==========================================================================
* inittoolmaster
*=========================================================================*/

struct ToolMaster * __saveds __stdargs inittoolmaster(void)

{
	memset((char *)&master,0,sizeof(struct ToolMaster));
	master.toolsize = TOOL_SIZE;
	master.toolid = TOOLID;
	master.edittool = edittool;
	master.processevent = processevent;
//	master.processlist = processlist;
	master.image = &ImageDown;
	strcpy(master.name,WTITLE);
	master.tooltype = TOOL_NORMAL;


	return(&master);
}
